//+------------------------------------------------------------------+
//|                                   FerruFx_Multi_info+_2_v1.1.mq4 |
//|                                        Copyright  2007, FerruFx |
//|                                                                  |
//+------------------------------------------------------------------+

// Version v1.1:

// 1. In this version, we give more force to the high TFs for the Up&DOWN calculation
//    Idea from yorkyjohnny on TSD forum (http://www.forex-tsd.com)

// 2. Possibility to display the "Open Trade Analysis", "Daily Pivots" and "Daily Range"
//    on the chart window (for the small screens!). Requested by some members on TSD forum (http://www.forex-tsd.com)

// 3. Bug for "Max lot to trade" solved

// 4. Removal W1 Timeframe

// Version v1.3 :
// Major code cleanup by Robert Hill aka MrPip


#property indicator_separate_window

#property indicator_minimum 0
#property indicator_maximum 1

#property indicator_buffers 2

//---- For the small screens
extern string    Display_infos         = "=== If true, displayed on the chart ===";
extern bool      display_on_chart      =    false;  // If true, the open trade analysis, daily pivots and daily range will be displayed on the chart window

//---- Open trade info parameters
extern string    Trade_info            = "=== Trade Info ===";
extern bool      AccountMini           =     true;  // If false, account is standard
extern double    LeverageToTrade       =      5.0;  // Leverage which you want to trade per position (e.g. you have a 200:1 account and you want to trade 10:1 of this leverage, just put 10)
extern double    PipValue              =    0.832;  // Pip Value

//---- Level to change the strength "weak" to "strong"
extern double TrendStrongLevel = 75.00;

//---- Calculation of the trend. Let's give high TFs more "force"
extern string    Coefs_high_TF         = "=== SUM must be = 7 ===";
extern double    coef_m1               =      1.0;
extern double    coef_m5               =      1.0;
extern double    coef_m15              =      1.0;
extern double    coef_m30              =      1.0;
extern double    coef_H1               =      1.0;
extern double    coef_H4               =      1.0;
extern double    coef_D1               =      1.0;
// extern double    coef_W1               =      1.0;

// indicators parameters

extern string    Shift_Settings_test_only        = "=== Format: 2007.05.02 00:00 ===";
extern datetime  look_time_shift       = D'2007.05.07 00:00';  // Shift for test if "test" is true
extern double    shift_indicators      =                   0;  // Shift for indicators if "test" is false
extern bool      test                  =               false;

//---- buffers
double TrendUPBuffer[];
double TrendDOWNBuffer[];

string    STOCHASTIC_Settings   = "=== STOCHASTIC Settings ===";
int       STOKPeriod            =            5;  // Stochastic %K  period
int       STODPeriod            =            3;  // Stochastic %D  period
int       STOSlowing            =            3;  // Stochastic slowing

string    RSI_Settings          = "=== RSI Settings ===";
int       RSIPeriod             =           14;  // RSI  period

string    FORCE_Settings        = "=== FORCE INDEX Settings ===";
int       FIPeriod              =           14;  // Force Index period
int       FIMethod              =     MODE_SMA;  // Force Index method
int       FIPrice               =  PRICE_CLOSE;  // Force Index price

string    MOMENTUM_Settings     = "=== MOMENTUM INDEX Settings ===";
int       MOMPeriod             =           14;  // Momentum period
int       MOMPrice              =  PRICE_CLOSE;  // Momentum price

string    DeMARKER_Settings     = "=== DeMARKER Settings ===";
int       DEMPeriod             =           14;  // DeMarker  period

int TimeZone=0;
bool pivots = true;
bool alert = true;

double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;

double rates_h1[2][6];
double rates_d1[2][6];

double UP[7][8];
double DOWN[7][8];

string ObjectID = "FMI_";
string short_name="FerruFx_Multi_info+";

// vars moved from start function
   int WindowToUse;
   color color_common_line = White;
   color color_common_text = White;
   color color_ind = PowderBlue;
   color color_indic;
   color color_pivots_1=PaleVioletRed;
   double x;
   double shift_1, shift_5, shift_15, shift_30, shift_60, shift_240, shift_1440, shift_10080;
   int add_x, add_y;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   IndicatorShortName(short_name);
   
   SetIndexBuffer(0,TrendUPBuffer);
   SetIndexBuffer(1,TrendDOWNBuffer);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {   
   delete_objects();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   double coef = coef_m1 + coef_m5 + coef_m15 + coef_m30 + coef_H1 + coef_H4 + coef_D1;
   if( coef != 7 ) { Alert("The sum of the coefs must be 7. Your setting is ", coef,"!!!"); }
  
  int j,total=OrdersTotal();
   for(j=0;j<total;j++)
   {
    OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
   }
   
   
// Shift calculation for indicators (tests only)

   
   if( test == true )
   {
    shift_1=iBarShift(NULL,PERIOD_M1,look_time_shift,false);
    shift_5=iBarShift(NULL,PERIOD_M5,look_time_shift,false);
    shift_15=iBarShift(NULL,PERIOD_M15,look_time_shift,false);
    shift_30=iBarShift(NULL,PERIOD_M30,look_time_shift,false);
    shift_60=iBarShift(NULL,PERIOD_H1,look_time_shift,false);
    shift_240=iBarShift(NULL,PERIOD_H4,look_time_shift,false);
    shift_1440=iBarShift(NULL,PERIOD_D1,look_time_shift,false);
    shift_10080=iBarShift(NULL,PERIOD_W1,look_time_shift,false);
   }
   else
   {
    shift_1=shift_indicators;
    shift_5=shift_indicators;
    shift_15=shift_indicators;
    shift_30=shift_indicators;
    shift_60=shift_indicators;
    shift_240=shift_indicators;
    shift_1440=shift_indicators;
    shift_10080=shift_indicators;
  }
   
//---- calculation for the label's X/Y

   
   if(display_on_chart == true)
   {   
    add_x = -160;
    add_y = 25;
   }
   else
   {
    add_x = 0;
    add_y = 10;
   }
   WindowToUse = WindowFind(short_name);
   DisplayStoch(0);  // Indicator (STOCH)
   DisplayRSI(1); // Indicator (RSI)
   DisplayForce(2);  // Indicator (FORCE INDEX)
   DisplayMomentum(3);  // Indicator (MOMENTUM)
   DisplayDemarker(4); // Indicator (DE MARKER)
   DisplayWAE(5); // Indicator (Waddah Attar Explosion)
   DisplayFerruTrend();
   DisplayPivots();
   return(0);
}

// Indicator (STOCH)
void DisplayStoch(int i)
{

   DisplayObject("stoch", WindowToUse, "STOCH",9, "Verdana", color_ind, 0, 601+add_x, -5+add_y);
   DisplayStoch_Trend("Trend_STO_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayStoch_Trend("Trend_STO_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayStoch_Trend("Trend_STO_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayStoch_Trend("Trend_STO_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayStoch_Trend("Trend_STO_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayStoch_Trend("Trend_STO_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayStoch_Trend("Trend_STO_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayStoch_Trend("Trend_STO_10080",PERIOD_W1,shift_10080, 127, i, 7);
}

void DisplayStoch_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{  
   string STOCH_Trend;
   
   double stoch_m_1=iStochastic(NULL,myPeriod,STOKPeriod,STODPeriod,STOSlowing,MODE_SMA,1,MODE_MAIN,myShift);
   double stoch_s_1=iStochastic(NULL,myPeriod,STOKPeriod,STODPeriod,STOSlowing,MODE_SMA,1,MODE_SIGNAL,myShift);

   if (stoch_m_1 >= stoch_s_1) { STOCH_Trend = "UP"; x = 616; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (stoch_m_1 < stoch_s_1) { STOCH_Trend = "DOWN"; x = 606; color_indic = Red; UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, STOCH_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}   

// Indicator (RSI)
void DisplayRSI(int i)
{
   DisplayObject("rsi", WindowToUse, "RSI",9, "Verdana", color_ind, 0, 662+add_x, -5+add_y);
   DisplayRSI_Trend("Trend_RSI_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayRSI_Trend("Trend_RSI_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayRSI_Trend("Trend_RSI_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayRSI_Trend("Trend_RSI_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayRSI_Trend("Trend_RSI_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayRSI_Trend("Trend_RSI_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayRSI_Trend("Trend_RSI_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayRSI_Trend("Trend_RSI_10080",PERIOD_W1,shift_10080, 127, i, 7);
}
   
void DisplayRSI_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{
   string RSI_Trend;
   
   double rsi_1=iRSI(NULL,myPeriod,RSIPeriod,PRICE_CLOSE,myShift);
   
   if (rsi_1 >= 50) { RSI_Trend = "UP"; x = 666; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (rsi_1 < 50) { RSI_Trend = "DOWN"; x = 656; color_indic = Red; UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, RSI_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}

// Indicator (FORCE INDEX)
void DisplayForce(int i)
{
   DisplayObject("force", WindowToUse, "FORCE",9, "Verdana", color_ind, 0, 701+add_x, -5+add_y);
   DisplayForce_Trend("Trend_FI_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayForce_Trend("Trend_FI_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayForce_Trend("Trend_FI_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayForce_Trend("Trend_FI_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayForce_Trend("Trend_FI_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayForce_Trend("Trend_FI_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayForce_Trend("Trend_FI_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayForce_Trend("Trend_FI_10080",PERIOD_W1,shift_10080, 127, i, 7);
   
}

void DisplayForce_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{
   string FI_Trend;
   
   double fi_1=iForce(NULL,myPeriod,FIPeriod,FIMethod,FIPrice,myShift);
   
   if (fi_1 >= 0){ FI_Trend = "UP"; x = 716; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (fi_1 < 0) { FI_Trend = "DOWN"; x = 706; color_indic = Red; UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, FI_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}
   
// Indicator (MOMENTUM)
void DisplayMomentum(int i)
{
   DisplayObject("momentum", WindowToUse, "MOM",9, "Verdana", color_ind, 0, 758+add_x, -5+add_y);
   DisplayMomentum_Trend("Trend_MOM_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayMomentum_Trend("Trend_MOM_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayMomentum_Trend("Trend_MOM_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayMomentum_Trend("Trend_MOM_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayMomentum_Trend("Trend_MOM_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayMomentum_Trend("Trend_MOM_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayMomentum_Trend("Trend_MOM_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayMomentum_Trend("Trend_MOM_10080",PERIOD_W1,shift_10080, 127, i, 7);
}

void DisplayMomentum_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{
   string MOM_Trend;
   
   double momentum_1=iMomentum(NULL,myPeriod,MOMPeriod,MOMPrice,myShift);
   
   if (momentum_1 >= 100) {  MOM_Trend = "UP"; x = 766; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (momentum_1 < 100) { MOM_Trend = "DOWN"; x = 756; color_indic = Red; UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, MOM_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}
  
// Indicator (DE MARKER)
void DisplayDemarker(int i)
{
   DisplayObject("demarker", WindowToUse, "DeM",9, "Verdana", color_ind, 0, 808+add_x, -5+add_y);
   DisplayDemarker_Trend("Trend_DEM_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayDemarker_Trend("Trend_DEM_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayDemarker_Trend("Trend_DEM_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayDemarker_Trend("Trend_DEM_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayDemarker_Trend("Trend_DEM_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayDemarker_Trend("Trend_DEM_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayDemarker_Trend("Trend_DEM_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayDemarker_Trend("Trend_DEM_10080",PERIOD_W1,shift_10080, 127, i, 7);
}
   
void DisplayDemarker_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{
   string DEM_Trend;

   double demarker_1_0=iDeMarker(NULL,myPeriod,DEMPeriod,myShift);
   double demarker_1_1=iDeMarker(NULL,myPeriod,DEMPeriod,myShift+1);
   
   if (demarker_1_0 >= demarker_1_1) { DEM_Trend = "UP"; x = 816; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (demarker_1_0 < demarker_1_1) { DEM_Trend = "DOWN"; x = 806; color_indic = Red; UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, DEM_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}
   
// Indicator (Waddah Attar Explosion)
void DisplayWAE(int i)
{
   DisplayObject("wae", WindowToUse, "WAE",9, "Verdana", color_ind, 0, 858+add_x, -5+add_y);
   DisplayWAE_Trend("Trend_WAE_1",PERIOD_M1,shift_1, 22, i, 0);
   DisplayWAE_Trend("Trend_WAE_5",PERIOD_M5,shift_5, 37, i, 1);
   DisplayWAE_Trend("Trend_WAE_15",PERIOD_M15,shift_15, 52, i, 2);
   DisplayWAE_Trend("Trend_WAE_30",PERIOD_M30,shift_30, 67, i, 3);
   DisplayWAE_Trend("Trend_WAE_60",PERIOD_H1,shift_60, 82, i, 4);
   DisplayWAE_Trend("Trend_WAE_240",PERIOD_H4,shift_240, 97, i, 5);
   DisplayWAE_Trend("Trend_WAE_1440",PERIOD_D1,shift_1440, 112, i, 6);
//   DisplayWAE_Trend("Trend_WAE_10080",PERIOD_W1,shift_10080, 127, i, 7);

}

void DisplayWAE_Trend(string myLabel, int myPeriod, int myShift, int myY, int i, int j)
{
   string WAE_Trend;
   
   double wae_histo_up_1_0 = iCustom(NULL,myPeriod,"Waddah_Attar_Explosion",150,30,15,15,false,1,true,true,true,true,0,myShift);
   double wae_histo_up_1_1 = iCustom(NULL,myPeriod,"Waddah_Attar_Explosion",150,30,15,15,false,1,true,true,true,true,0,myShift+1);
   double wae_histo_down_1_0 = iCustom(NULL,myPeriod,"Waddah_Attar_Explosion",150,30,15,15,false,1,true,true,true,true,1,myShift);
   double wae_histo_down_1_1 = iCustom(NULL,myPeriod,"Waddah_Attar_Explosion",150,30,15,15,false,1,true,true,true,true,1,myShift+1);
   
   if (wae_histo_up_1_0 > wae_histo_up_1_1 || wae_histo_down_1_0 < wae_histo_down_1_1) { WAE_Trend = "UP"; x = 866; color_indic = Lime; UP[i][j] = 1; DOWN[i][j] = 0; }
   if (wae_histo_up_1_0 < wae_histo_up_1_1 || wae_histo_down_1_0 > wae_histo_down_1_1) { WAE_Trend = "DOWN"; x = 856; color_indic = Red;  UP[i][j] = 0; DOWN[i][j] = 1; }
   DisplayObject(myLabel, WindowToUse, WAE_Trend,7, "Verdana", color_indic, 0, x+add_x, myY+add_y);
}

void DisplayFerruTrend()
{
  double sumUP[8], sumDOWN[8];

//Calculation of the trend. Let's give high TFs more "force"
   
   double Trend_UP_1;
   double Trend_DOWN_1;
    Trend_UP_1 = iCustom(NULL,0,"FerruFx_Multi_info+_v1.1","=== If true, displayed on the chart ===",display_on_chart,"=== Trade Info ===",AccountMini,LeverageToTrade,PipValue,"=== SUM must be = 8 ===",coef_m1,coef_m5,coef_m15,coef_m30,coef_H1,coef_H4,coef_D1 /* ,coef_W1 */ ,"=== Format: 2007.05.07 00:00 ===",look_time_shift,shift_indicators,test,0,0);
    Trend_DOWN_1 = iCustom(NULL,0,"FerruFx_Multi_info+_v1.1","=== If true, displayed on the chart ===",display_on_chart,"=== Trade Info ===",AccountMini,LeverageToTrade,PipValue,"=== SUM must be = 8 ===",coef_m1,coef_m5,coef_m15,coef_m30,coef_H1,coef_H4,coef_D1 /* ,coef_W1 */ ,"=== Format: 2007.05.07 00:00 ===",look_time_shift,shift_indicators,test,1,0);
   
   for (int i = 0; i < 7; i++)
   {
      sumUP[i] = 0.0;
      sumDOWN[i] = 0.0;
      for (int j = 0; j <= 5; j++){ sumUP[i] += UP[i][j]; sumDOWN[i] += DOWN[i][j]; }
   }
   double UP_m1 = sumUP[0] * coef_m1;
   double UP_m5 = sumUP[1] * coef_m5;
   double UP_m15 = sumUP[2] * coef_m15;
   double UP_m30 = sumUP[3] * coef_m30;
   double UP_H1 = sumUP[4] * coef_H1;
   double UP_H4 = sumUP[5] * coef_H4;
   double UP_D1 = sumUP[6] * coef_D1;
   // double UP_W1 = sumUP[7] * coef_W1;
   
   double Trend_UP_2 = UP_m1 + UP_m5 + UP_m15 + UP_m30 + UP_H1 + UP_H4 + UP_D1 /* + UP_W1 */ ;
       
   double DOWN_m1 = sumDOWN[0] * coef_m1;
   double DOWN_m5 = sumDOWN[1] * coef_m5;
   double DOWN_m15 = sumDOWN[2] * coef_m15;
   double DOWN_m30 = sumDOWN[3] * coef_m30;
   double DOWN_H1 = sumDOWN[4] * coef_H1;
   double DOWN_H4 = sumDOWN[5] * coef_H4;
   double DOWN_D1 = sumDOWN[6] * coef_D1;
   // double DOWN_W1 = sumDOWN[7] * coef_W1;
                               
   double Trend_DOWN_2 = DOWN_m1 + DOWN_m5 + DOWN_m15 + DOWN_m30 + DOWN_H1 + DOWN_H4 + DOWN_D1 /* + DOWN_W1 */ ;
                             
   string Trend_UP = DoubleToStr((((Trend_UP_1 + Trend_UP_2)/98)*100),0);
   string Trend_DOWN = DoubleToStr((100 - StrToDouble(Trend_UP)),0);
   
/*
   Buffers for EA
   
   TrendUPBuffer[0] = ((Trend_UP_1 + Trend_UP_2)/98)*100;
   TrendDOWNBuffer[0] = 100 - (((Trend_UP_1 + Trend_UP_2)/98)*100);
   
*/
   
   DisplayObject("Trend_UP", WindowToUse, "+   Trend   +",9, "Verdana", DarkOrange, 0, 908+add_x, -5+add_y);
   DisplayObject("line9", WindowToUse, "----------------",8, "Verdana", DarkOrange, 0, 907+add_x, 6+add_y);
   DisplayObject("Trend_UP_text", WindowToUse, "UP",9, "Verdana", Lime, 0, 909+add_x, 20+add_y);
   DisplayObject("Trend_UP_value", WindowToUse, Trend_UP+"%",9, "Verdana", PeachPuff, 0, 955+add_x, 20+add_y);
   DisplayObject("Trend_DOWN_text", WindowToUse, "DOWN",9, "Verdana", Red, 0, 909+add_x, 40+add_y);
   DisplayObject("Trend_DOWN_value", WindowToUse, Trend_DOWN+"%",9, "Verdana", PeachPuff, 0, 955+add_x, 40+add_y);
   
   string trend;
   string comment;
   color coltrend;
   color colcomment;
   double xt, xc;
   
   if(StrToDouble(Trend_UP) >= TrendStrongLevel) { trend = "UP"; coltrend = Lime; xt = 935; comment = "[strong]"; xc = 921; colcomment = Lime; /* if (alert == true) { Alert(TimeToStr(TimeCurrent(),TIME_SECONDS)," Trend UP > "TrendStrongLevel"% on ",Symbol()," ", Bid); PlaySound("tick.wav"); } */ }
   else if(StrToDouble(Trend_UP) < TrendStrongLevel && StrToDouble(Trend_UP) >= 50) { trend = "UP"; coltrend = Lime; xt = 935; comment = "[weak]"; xc = 924; colcomment = Orange; }
   else if(StrToDouble(Trend_DOWN) >= TrendStrongLevel) { trend = "DOWN"; coltrend = Red; xt = 918; comment = "[strong]"; xc = 921; colcomment = Red; /* if (alert == true) { Alert(TimeToStr(TimeCurrent(),TIME_SECONDS)," Trend DOWN > "TrendStrongLevel"% on ",Symbol()," ", Bid); PlaySound("tick.wav"); } */ }
   else if(StrToDouble(Trend_DOWN) < TrendStrongLevel && StrToDouble(Trend_DOWN) > 50) { trend = "DOWN"; coltrend = Red; xt = 918; comment = "[weak]"; xc = 924; colcomment = Orange; }
   
   DisplayObject("line10", WindowToUse, "----------------",8, "Verdana", coltrend, 0, 907+add_x, 55+add_y);
   DisplayObject("line12", WindowToUse, "----------------",8, "Verdana", coltrend, 0, 907+add_x, 58+add_y);
   DisplayObject("Trend", WindowToUse, trend,18, "Impact", coltrend, 0, xt+add_x, 70+add_y);
   DisplayObject("Trend_comment", WindowToUse, comment,10, "Verdana", colcomment, 0, xc+add_x, 100+add_y);
   DisplayObject("line13", WindowToUse, "----------------",8, "Verdana", coltrend, 0, 907+add_x, 117+add_y);
   DisplayObject("line11", WindowToUse, "----------------",8, "Verdana", coltrend, 0, 907+add_x, 120+add_y);
   
}

void DisplayPivots()
{   
// DAILY PIVOTS AND RANGE
   
//---- Get new daily prices

   ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);
   
//---- modifs ibfx
   int offset = 0;
   if(DayOfWeek()==1) offset=1;
//----

   double day_high[51], day_low[51];
   int i=0;
   
   for (i = 50; i >= 0; i--)
   {
      day_high[i] = rates_d1[i+offset][3];
      day_low[i] = rates_d1[i+offset][2];
   }
   
   double yesterday_high = rates_d1[1+offset][3];
   double yesterday_low = rates_d1[1+offset][2];
   double yesterday_close = rates_d1[1+offset][4];
   
/*

   ArrayCopyRates(rates_h1, Symbol(), PERIOD_H1);
   for (i=0;i<=25;i++)
   {
    if (TimeMinute(rates_h1[i][0])==0 && (TimeHour(rates_h1[i][0])-TimeZone)==0)
    {
     yesterday_close = rates_h1[i+1][4];      
     yesterday_open = rates_h1[i+24][1];
     today_open = rates_h1[i][1];      
     break;
    }
   }
*/

//---- Calculate Pivots et range

   double D = day_high[0] - day_low[0];
   double Q[51];
   for (i = 0; i < 51; i++) Q[i] = day_high[i] - day_low[i];
//   double Q = (yesterday_high - yesterday_low);
   double P = (yesterday_high + yesterday_low + yesterday_close) / 3;
   double R1 = (2*P)-yesterday_low;
   double S1 = (2*P)-yesterday_high;
   double R2 = P+(R1 - S1);
   double S2 = P-(R1 - S1);
	double R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	double S3 = (2*P)-((2* yesterday_high)-yesterday_low);
	
	
	
	
	
	int Precision, dig;
{
   if( StringFind( Symbol(), "JPY", 0) != -1 ) { Precision = 100; dig = 2;}
   else                                        { Precision = 10000; dig = 4; }
} 
	double D0 = D * Precision;
	double Q0 = Q[1] * Precision;
	double Q5_sum = Q[1] + Q[2] + Q[3] + Q[4] + Q[5];
	double Q5_av = (Q5_sum / 5) * Precision;
	double Q10_sum = Q5_sum + Q[6] + Q[7] + Q[8] + Q[9] + Q[10];
	double Q10_av = (Q5_sum / 10) * Precision;
	double Q20_sum = Q10_sum + Q[11] + Q[12] + Q[13] + Q[14] + Q[15] + Q[16] + Q[17] + Q[18] + Q[19] + Q[20];
	double Q20_av = (Q20_sum / 20) * Precision;
	/*
	double Q30_sum = Q20_sum + Q[21] + Q[22] + Q[23] + Q[24] + Q[25] + Q[26] + Q[27] + Q[28] + Q[29] + Q[30];
	double Q30_av = (Q30_sum  / 30) * Precision;
	double Q40_sum = Q30_sum + Q[31] + Q[32] + Q[33] + Q[34] + Q[35] + Q[36] + Q[37] + Q[38] + Q[39] + Q[40];
	double Q40_av = (Q40_sum / 40) * Precision;
	*/
	double Q50_sum = 0;
	for (i = 21; i <= 50;i++) Q50_sum += Q[i];
	Q50_sum += Q20_sum;
	double Q50_av = (Q50_sum / 50) * Precision;
	
	double average_range = (Q0 + Q5_av + Q10_av + Q20_av + Q50_av) / 5;
	
	
//---- Set Pivots labels

   int Corner_line, Xdist_line;
   int Corner_text, Corner_value, Xdist_text, Xdist_value;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_R3, Ydist_R2, Ydist_R1, Ydist_PV, Ydist_S1, Ydist_S2, Ydist_S3;
  
   if(display_on_chart == true)
   {   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_value = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_value = 23;
    Ydist_line5 = 179;
    Corner_pivots = 1; Xdist_pivots = 21; Ydist_pivots = 168;
    Ydist_R3 = 193; Ydist_R2 = 208; Ydist_R1 = 223; Ydist_PV = 238; Ydist_S1 = 253; Ydist_S2 = 268; Ydist_S3 = 283;
   }
   else
   {
    WindowToUse = WindowFind(short_name);
    Corner_line = 0; Corner_text = 0; Corner_value = 0;
    Xdist_line = 1010; Xdist_text = 1013; Xdist_value = 1050;
    Ydist_line5 = 16;
    Corner_pivots = 0; Xdist_pivots = 1010; Ydist_pivots = 5;
    Ydist_R3 = 30; Ydist_R2 = 45; Ydist_R1 = 60; Ydist_PV = 75; Ydist_S1 = 90; Ydist_S2 = 105; Ydist_S3 = 120;
   }

   DisplayObject("pivots", WindowToUse, "+Daily Pivots+",9, "Verdana", color_pivots_1, Corner_pivots, Xdist_pivots, Ydist_pivots);
   DisplayObject("line5", WindowToUse, "------------------",7, "Verdana", color_pivots_1, Corner_line, Xdist_line, Ydist_line5);
   DisplayObject("R3_Label", WindowToUse, "R3",9, "Verdana", Gainsboro, Corner_text, Xdist_text, Ydist_R3);
   DisplayObject("R3_Value", WindowToUse, " "+DoubleToStr(R3,dig),9, "Verdana", Gainsboro, Corner_value, Xdist_value, Ydist_R3);
   DisplayObject("R2_Label", WindowToUse, "R2",9, "Verdana", Silver, Corner_text, Xdist_text, Ydist_R2);
   DisplayObject("R2_Value", WindowToUse, " "+DoubleToStr(R2,dig),9, "Verdana", Silver, Corner_value, Xdist_value, Ydist_R2);
   DisplayObject("R1_Label", WindowToUse, "R1",9, "Verdana", DarkGray, Corner_text, Xdist_text, Ydist_R1);
   DisplayObject("R1_Value", WindowToUse, " "+DoubleToStr(R1,dig),9, "Verdana", DarkGray, Corner_value, Xdist_value, Ydist_R1);
   DisplayObject("Pivot_Label", WindowToUse, "PV",9, "Verdana", Gray, Corner_text, Xdist_text, Ydist_PV);
   DisplayObject("Pivot_Value", WindowToUse, " "+DoubleToStr(P,dig),9, "Verdana", Gray, Corner_value, Xdist_value, Ydist_PV);
   DisplayObject("S1_Label", WindowToUse, "S1",9, "Verdana", DarkGray, Corner_text, Xdist_text, Ydist_S1);
   DisplayObject("S1_Value", WindowToUse," "+DoubleToStr(S1,dig),9, "Verdana", DarkGray, Corner_value, Xdist_value, Ydist_S1);
   DisplayObject("S2_Label", WindowToUse,"S2",9, "Verdana", Silver, Corner_text, Xdist_text, Ydist_S2);
   DisplayObject("S2_Value", WindowToUse," "+DoubleToStr(S2,dig),9, "Verdana", Silver, Corner_value, Xdist_value, Ydist_S2);
   DisplayObject("S3_Label", WindowToUse, "S3",9, "Verdana", Gainsboro, Corner_text, Xdist_text, Ydist_S3);
   DisplayObject("S3_Value", WindowToUse," "+DoubleToStr(S3,dig),9, "Verdana", Gainsboro, Corner_value, Xdist_value, Ydist_S3);
   
   
   
// DAILY RANGE

   int Ydist_line6, Ydist_line7, Ydist_line8;
   int Corner_range, Xdist_range, Ydist_range;
   int Ydist_today, Ydist_yesterday, Ydist_5, Ydist_10, Ydist_20, Ydist_50;
   int Ydist_average;
  
   if(display_on_chart == true)
   {   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_value = 1;
    Xdist_line = 21; Xdist_text = 55; Xdist_value = 23;
    Ydist_line6 = 314; Ydist_line7 = 415; Ydist_line8 = 430;
    Corner_range = 1; Xdist_range = 21; Ydist_range = 303;
    Ydist_today = 328; Ydist_yesterday = 343; Ydist_5 = 358; Ydist_10 = 373; Ydist_20 = 388; Ydist_50 = 403; Ydist_average = 421;
   }
   else
   {
    WindowToUse = WindowFind(short_name);
    Corner_line = 0; Corner_text = 0; Corner_value = 1;
    Xdist_line = 1121; Xdist_text = 1124; Xdist_value = 24;
    Ydist_line6 = 16; Ydist_line7 = 112; Ydist_line8 = 127;
    Corner_range = 0; Xdist_range = 1120; Ydist_range = 5;
    Ydist_today = 28; Ydist_yesterday = 42; Ydist_5 = 57; Ydist_10 = 72; Ydist_20 = 87; Ydist_50 = 102; Ydist_average = 118;
   }

   DisplayObject("daily_range", WindowToUse,"+Daily Range+",9, "Verdana", MediumTurquoise, Corner_range, Xdist_range, Ydist_range);
   DisplayObject("line6", WindowToUse,"------------------",8, "Verdana", MediumTurquoise, Corner_line, Xdist_line, Ydist_line6);
   DisplayObject("today", WindowToUse,"Today",9, "Verdana", WhiteSmoke, Corner_text, Xdist_text, Ydist_today);
   DisplayObject("today_range", WindowToUse,DoubleToStr(D0,0),9, "Verdana", WhiteSmoke, Corner_value, Xdist_value, Ydist_today);
   DisplayObject("yesterday", WindowToUse, "1 Day",9, "Verdana", Gainsboro, Corner_text, Xdist_text, Ydist_yesterday);
   DisplayObject("yesterday_range", WindowToUse,DoubleToStr(Q0,0),9, "Verdana", Gainsboro, Corner_value, Xdist_value, Ydist_yesterday);
   DisplayObject("5_days", WindowToUse,"5 Days",9, "Verdana", LightGray, Corner_text, Xdist_text, Ydist_5);
   DisplayObject("5_days_range", WindowToUse,DoubleToStr(Q5_av,0),9, "Verdana", LightGray, Corner_value, Xdist_value, Ydist_5);
   DisplayObject("10_days", WindowToUse, "10 Days",9, "Verdana", Silver, Corner_text, Xdist_text, Ydist_10);
   DisplayObject("10_days_range", WindowToUse,DoubleToStr(Q10_av,0),9, "Verdana", Silver, Corner_value, Xdist_value, Ydist_10);
   DisplayObject("20_days", WindowToUse, "20 Days",9, "Verdana", DarkGray, Corner_text, Xdist_text, Ydist_20);
   DisplayObject("20_days_range", WindowToUse,DoubleToStr(Q20_av,0),9, "Verdana", DarkGray, Corner_value, Xdist_value, Ydist_20);
   DisplayObject("50_days", WindowToUse,"50 Days",9, "Verdana", Gray, Corner_text, Xdist_text , Ydist_50);
   DisplayObject("50_days_range", WindowToUse,DoubleToStr(Q50_av,0),9, "Verdana", Gray, Corner_value, Xdist_value, Ydist_50);
   DisplayObject("line7", WindowToUse,"------------------",8, "Verdana", PeachPuff, Corner_line, Xdist_line, Ydist_line7);
   DisplayObject("Average", WindowToUse,"Average",9, "Verdana", Coral, Corner_text, Xdist_text, Ydist_average);
   DisplayObject("Average_range", WindowToUse,DoubleToStr(average_range,0),9, "Verdana", SandyBrown, Corner_value, Xdist_value, Ydist_average);
   DisplayObject("line8", WindowToUse,"------------------",8, "Verdana", PeachPuff, Corner_line, Xdist_line, Ydist_line8);
}
   

void DisplayObject(string mObject, int myWindow, string msg, int FontSize, string FontName, color FontColor, int myCorner, int x_position, int y_position)
{
   string myObject;
   
   myObject = ObjectID + mObject;
   
         
   if (ObjectFind(myObject) == -1 ){
      ObjectCreate(myObject, OBJ_LABEL, myWindow, 0, 0);
      ObjectSet(myObject, OBJPROP_CORNER, myCorner);
   }
   ObjectSet(myObject, OBJPROP_XDISTANCE, x_position);
   ObjectSet(myObject, OBJPROP_YDISTANCE, y_position);
   ObjectSetText(myObject,msg, FontSize,FontName,FontColor);
}

void delete_objects()
{

   int i, tot;
   string object_name;

   tot = ObjectsTotal();
   
   for (i = tot; i>=0;i--)
   {
    object_name = ObjectName(i);
    if (StringFind(object_name, ObjectID) > -1 ) ObjectDelete(object_name);
   }
}

